unit Unit1ReceptionMessage;
//Michel Bardou http://www.phidels.com
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    EditReceptionTexte: TEdit;
    SpinEditReceptionNombre: TSpinEdit;
    procedure FormCreate(Sender: TObject);
  private
    NumMessage : UINT;// num de notre message
  public
    // procedure qui sera dclenche lorsqu'un message WM_COPYDATA arrivera
    procedure OnWmCopyData(var msg:TMessage); message WM_COPYDATA;
  end;

var
  Form1 : TForm1;

implementation

{$R *.DFM}
Type
//TPDataEnvoyes est un type pointeur (adresse) sur un TDataEnvoyes :
TPDataEnvoyes=^TDataEnvoyes;
TDataEnvoyes =Packed record
  UnEntier:Integer;
  UneChaine:String[255];
end;


procedure TForm1.OnWmCopyData(var msg: TMessage);
// procedure qui sera dclenche lorsqu'un message WM_COPYDATA arrivera
type
  TPCopyDataStruct=^TCopyDataStruct;
  TPDataEnvoyes=^TDataEnvoyes;
Var
  DataEnvoyes:TDataEnvoyes;
  PDataEnvoyes:TPDataEnvoyes;
  PCopyDataStruct:TPCopyDataStruct;
begin
  PCopyDataStruct:=TPCopyDataStruct(msg.LParam);
  //PCopyDataStruct^ signifie "ce qui est point par le PCopyDataStruct"
  PDataEnvoyes:=PCopyDataStruct^.lpData;
  DataEnvoyes:=PDataEnvoyes^;

  EditReceptionTexte.Text:=DataEnvoyes.UneChaine;
  SpinEditReceptionNombre.Value:=DataEnvoyes.UnEntier;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  NumMessage:=RegisterWindowMessage('Message perso de application');
  Form1.Caption:='Fentre rceptrice de messages';
end;
end.
